/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package CSP_CREATOR;

import LOGIC.BoolType;
import LOGIC.Channel;
import LOGIC.Contract;
import LOGIC.Datatype;
import LOGIC.IntervalType;
import LOGIC.ObjectList;
import LOGIC.Type;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author sarah
 */
public class CreatorBehaviorChecker {

    private Contract contract;
    private String cspChecker = "";
    private ObjectList objList;
  
    public CreatorBehaviorChecker(Contract c, ObjectList l) {
        contract = c;
        objList = l;
        
    }

    public String getCspChecker() {
        return cspChecker;
    }

    public void setCspChecker(String cspChecker) {
        this.cspChecker = cspChecker;
    }

    public void CSPCheckerCreator() {

        
        for (int i = 0; i < contract.getType().size(); i++) {//para declarar todos os tipos contidos em ObjectList

            typeInstanciation(contract.getType().get(i));
  
        }

        for (int i = 0; i < contract.getChannel().size(); i++) {

            channelInstanciation(contract.getChannel().get(i));
        }
        /*
        for(int i=0; i< objList.getTypeList().size(); i++){
            typeInstanciation(objList.getTypeList().get(i));
        }
        for (int i = 0; i < objList.getChannelList().size(); i++) {

            channelInstanciation(objList.getChannelList().get(i));
        }*/
        
        
        //cspChecker = cspChecker + typeChannes.getTypeChannel();
        
        //cria arquivo para escrita do comportamento q será verificado pelo Checker
        FileWriter Wcsp = null;
        try {
            Wcsp = new FileWriter(new File("cspFiles/Comportamento.csp"));

            PrintWriter d = new PrintWriter(Wcsp);
            d.flush();
            // escreve no arquivo os tipos e canais que estão na string 'csp, em seguida escreve uma string com o
            // comportamento que é recebido do comtrato
            d.write(getCspChecker() + "\n\n" + contract.getBehavior());
            Wcsp.close();
            d.close();
        } catch (IOException ex) {
            Logger.getLogger(contract.getName()).log(Level.SEVERE, null, ex);

        }

    }
    
    public void typeInstanciation(Type tipo) {


        if (tipo instanceof BoolType) {
            setCspChecker(getCspChecker() + "\n" + tipo.getNome() + " = Bool");

        }
        // verificando se 'tipo é do tipo 'IntervalType
        if (tipo instanceof IntervalType) {
            //instanciando interval
            IntervalType interval = (IntervalType) tipo;
            setCspChecker(getCspChecker() + "\n" + tipo.getNome() + " = {" + interval.getMim() + ".." + interval.getMax() + "}");

        }

        if (tipo instanceof Datatype) {
            setCspChecker(getCspChecker() + "\n" + "datatype " + tipo.getNome() + " = ");
            //instanciando Datatype
            Datatype datatype = (Datatype) tipo;
            int j;
            for (j = 0; j < datatype.getDatatype().size(); j++) {
                if (j != 0) {
                    setCspChecker(getCspChecker() + " | ");
                }
                if (!datatype.getDatatype().get(j).getType().equals("")) {
                    setCspChecker(getCspChecker() + datatype.getDatatype().get(j).getName() + "." + datatype.getDatatype().get(j).getType());
                } else {
                    setCspChecker(getCspChecker() + datatype.getDatatype().get(j).getName());

                }
            }

        }
    }

    public void channelInstanciation(Channel Canal) {

        setCspChecker(getCspChecker() + "\nchannel " + Canal.getName() + " : ");
        for (int i = 0; i < Canal.getType().size(); i++) {
            if (i == Canal.getType().size() - 1) {
                setCspChecker(getCspChecker() + Canal.getType().get(i).getNome());
            } else {
                setCspChecker(getCspChecker() + Canal.getType().get(i).getNome() + ".");
            }
        }
    }
}
