/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package CSP_CREATOR;

import LOGIC.Contract;
import LOGIC.ObjectList;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author sarah
 */
public class CreatorContract {

    private Contract contract;
    private String cspFDR = "";
    private String include = "";
    private CreatorTypesAndChannels typeChannel;
    private CreatorIOProcess iop;
    
    public CreatorContract(Contract c, ObjectList l) {
        contract = c;
        typeChannel = new CreatorTypesAndChannels(l);
        iop = new CreatorIOProcess(c);
        typeChannel.creatorTypesChannels();
        iop.creatorIOProcess();
    }

    //criar CSP para ser verificado pelo FDR
    public void CSPFDRCreator() {

        //CHANNELS, INPUTS AND OUTPUTS
        getChannelC();
        inputsC();
        outputsC();
        cspFDR = cspFDR + iop.getIoprocess();
        
        //cria arquivo para escrita do comportamento q será verificado pelo FDR
        include = "include \"sequence_aux.csp\" \ninclude \"function_aux.csp\" \n"
                + "include \"auxiliar.csp\" \ninclude \"rules.csp\"";
        
        FileWriter ioprocess = null;
        try {
            ioprocess = new FileWriter(new File("cspFiles/"+contract.getName()+".csp"));

            PrintWriter p = new PrintWriter(ioprocess);
            p.flush();
            p.write(include + "\n" + typeChannel.getTypeChannel() + "\n\n" + contract.getBehavior() + "\n\n" + cspFDR );
            ioprocess.close();
            p.close();
        } catch (IOException ex) {
            Logger.getLogger(contract.getName()).log(Level.SEVERE, null, ex);

        }
    }

    public void getChannelC() {

        //channels
        cspFDR = cspFDR + "\nGET_CHANNELS(P) =";
        cspFDR = cspFDR + "\n \t let f =";
        cspFDR = cspFDR + "\n \t < \n \t(" + contract.getName() + ", { ";

        for (int i = 0; i < contract.getChannel().size(); i++) {

            if (i == contract.getChannel().size() - 1) {
                cspFDR = cspFDR + contract.getChannel().get(i).getName();
            } else {
                cspFDR = cspFDR + contract.getChannel().get(i).getName() + ",";
            }
        }
        cspFDR = cspFDR + " }) \n \t > \n";
        cspFDR = cspFDR + "\n \t within apply(f,P )";

    }

    public void inputsC() {


        //função inputs
        cspFDR = cspFDR + "\n";
        // verificação para o contrato
        cspFDR = cspFDR + "\ninputs(P) = ";
        cspFDR = cspFDR + "\n \t let f = \n";
        cspFDR = cspFDR + "\n \t < \n \t ( " + contract.getName() + ", {| ";
        // coloca todos os canais de in associado com seus tipos. ex: {|c.1, c.2|}
        for (int i = 0; i < contract.getIn().size(); i++) {

            if (i == contract.getIn().size() - 1) {
                cspFDR = cspFDR + contract.getIn().get(i).getEvento();
            } else {
                cspFDR = cspFDR + contract.getIn().get(i).getEvento() + ", ";
            }

        }
        cspFDR = cspFDR + " |}) \n \t > \n";
        cspFDR = cspFDR + "\n \t within apply(f, P )";
        cspFDR = cspFDR + "\n";
    }

    public void outputsC() {

        //função outputs
        cspFDR = cspFDR + "\noutputs(P) = ";
        cspFDR = cspFDR + "\n \t let f =";
        cspFDR = cspFDR + "\n \t < \n \t ( " + contract.getName() + ", {| ";
        // coloca todos os canais de out associado com seus tipos. ex: {|c.1, c.2|}
        for (int i = 0; i < contract.getOut().size(); i++) {
            if (i == contract.getOut().size() - 1) {
                cspFDR = cspFDR + contract.getOut().get(i).getEvento();
            } else {
                cspFDR = cspFDR + contract.getOut().get(i).getEvento() + ", ";
            }

        }
        cspFDR = cspFDR + " |}) \n \t >";
        cspFDR = cspFDR + "\n \t within apply(f,P)\n";


    }
}
